<?php
function widget_yhd_ducegoodscat(&$setting,&$system){
	
	$goodsCat = $virtualCat = array();

	if($setting['show_treetype']!=1){
		$o=$system->loadModel('goods/productCat');
		$setting['pageDevide']=$setting['pageDevide']?$setting['pageDevide']:2;
		$setting['view'] = $system->getConf('gallery.default_view');
		$brandGroup = ducedis_Catlist($goodsCat, $o->getTreeList(), $setting['ducedropdown2_CatDepth'], ($setting['showbrand'] && $setting['ducedropdown2']==1));
	}
	
	if($setting['show_treetype']){
		$objCat = $system->loadModel('goods/virtualcat');
		ducedis_Catlist($virtualCat, $objCat->getMapTree(0,'',$setting['show_virtualid']), $setting['ducedropdown2_CatDepth']);
		
		if($setting['show_treenode']=='off'){
			$temparr=array();
			foreach($virtualCat as $d){
				if($d['sub']){
					foreach($d['sub'] as $da){
						$temparr[]=$da;
					}
				}
			}
			$virtualCat=$temparr;
		}
		foreach($virtualCat as $id=>$cat){
			$goodsCat['t_'.$id] = $cat;
		}
	}	

	if($brandGroup){
		$cache = array();
		$file = MEDIA_DIR."/ducedis_cache_brand.data";
		$cachelife = intval($setting['cachelife']);
		$getcache = __ADMIN__ == 'admin' && $setting['refresh'] ? 0 : $cachelife;
		$timestamp = time();
		
		if($cachelife && $getcache){			
			$result = json_decode(file_get_contents($file), true);
			if($result[0] > $timestamp){
				$cachebrand = $result[1];
			}else{
				$getcache=0;
			}
		}
		if(!$getcache){
			$b=$system->loadModel('goods/brand');
			$brands=array();
			foreach((array)$b->getAll() as $v){
				$brands[$v['brand_id']] = $v['brand_name'];
			}
		}

		foreach($brandGroup as $catid=>$v){
			if($getcache){
				$goodsCat[$catid]['brands']=(array)$cachebrand[$catid];
			}else{
				foreach((array)ducedis_GetCatBrand($v, $o) as $a=>$k){
					if(!$k['brand_id']) continue;
					$goodsCat[$catid]['brands'][] = array(
						'id' => $k['brand_id'],
						'name' => $brands[$k['brand_id']],
						'plus' => $k['brand_cat'],
					);
				}
				if($cachelife){
					$cache[$catid] = $goodsCat[$catid]['brands'];
				}				
			}
		}
		if($cachelife && !$getcache){
			file_put_contents($file, json_encode(array($timestamp+$cachelife,$cache)));
		}
	}
    
    return $goodsCat;
}

function ducedis_Catlist(&$myData, $data, $CatDepth=3, $showbrand=false){
	$brandGroup = array();
    for($i=0;$i<count($data);$i++){
        $cat_path=$data[$i]['cat_path'];
        $cat_name=$data[$i]['cat_name'];
        $cat_id=$data[$i]['cat_id'];
        if(empty($cat_path) or $cat_path==","){
            $myData[$cat_id]['label']=$cat_name;    
            $myData[$cat_id]['cat_id']=$cat_id;
			$myData[$cat_id]['url']=$data[$i]['url'];
			if($showbrand) {
				$brandGroup[$cat_id][$cat_id]=$cat_id;
			}
        }
    }
    for($i=0;$i<count($data);$i++){
        $cat_path=$data[$i]['cat_path'];
        $cat_name=$data[$i]['cat_name'];
        $cat_id=$data[$i]['cat_id'];
		$url=$data[$i]['url'];
        $parent_id=$data[$i]['pid'];

        if(trim($cat_path) == ','){
            $count=0;
        }else{
            $count=count(explode(',',$cat_path));
        }
        if($count==2){//ڶ
            $c_1=intval($parent_id);
            $c_2=intval($cat_id);    
            $myData[$c_1]['sub'][$c_2]['label']=$cat_name;
            $myData[$c_1]['sub'][$c_2]['cat_id']=$cat_id;
			$myData[$c_1]['sub'][$c_2]['url']=$url;
			if($showbrand) {
				$brandGroup[$c_1][$c_2]=$c_2;
			}
        }
        if($count==3){//
            $tmp=explode(',',$cat_path);
            $c_1=intval($tmp[0]);
            $c_2=intval($tmp[1]);
            $c_3=intval($cat_id);
            $myData[$c_1]['sub'][$c_2]['sub'][$c_3]['label']=$cat_name;
            $myData[$c_1]['sub'][$c_2]['sub'][$c_3]['cat_id']=$cat_id;
			$myData[$c_1]['sub'][$c_2]['sub'][$c_3]['url']=$url;
			if($showbrand) {
				$brandGroup[$c_1][$c_2]=$c_2;
				$brandGroup[$c_1][$c_3]=$c_3;
			}
			if($CatDepth==3){
				$myData[$c_1]['depth']=3;
			}
        }
    }
	return $brandGroup;
}

function ducedis_GetCatBrand($cat_id, $o){
	if($cat_id){
		return $o->db->select("SELECT COUNT(brand_id) as brand_cat,brand_id From sdb_goods where cat_id IN(".implode(',',$cat_id).") AND marketable='true' AND disabled='false' GROUP By brand_id");
	}
	return array();
}

?>